
.nolist
include \masm32\include\masm32rt.inc
include \masm32\macros\timers.asm
.586

SzCopy_dw	PROTO :DWORD,:DWORD

; 
; OPT_Linker	polink	; use Pelle's linker
; OPT_DelTmp	0	; don't delete temporary files

mcBinSlots	= 20
mcHexSlots	= 20
mcStringSlots	= 10
mcDefBufLen	= 1024

CAT$ MACRO dest:REQ, src:VARARG
LOCAL SrcCt, isaddr, ia
	push edi
	mov edi, offset mcStrBuffer	;; will hold pointer to received strings
	SrcCt = 0
	FOR arg, <src>
		LOCAL nustr, quot, tmp$
		SrcCt = SrcCt + 1
		isaddr SUBSTR <arg>, 1, 4
		ia INSTR <ADDR Addr addr>, isaddr
		if ia
			tmp$  SUBSTR <arg>, 6
			tmp$  CATSTR <lea eax, >, tmp$
			tmp$  ;; insert lea eax, whatever
;			% echo tmp$
		else
			quot SUBSTR <arg>, 1, 1
			tmp$ equ <arg>
			ifidn quot, <">				;; if 1st char = "
				.data
				nustr db arg, 0			;; write arg to .data section
				.code
				tmp$ equ <offset nustr>
			endif
			ifdif tmp$, <eax>
				mov eax, tmp$
			endif
		endif
		stosd		;; move next string address into mcStrBuffer
          ENDM
	ia = @SizeStr(<dest>)
	tmp$ CATSTR <SizeIs >, %ia, < bytes>
	% echo <dest>
	% echo tmp$
	if ia lt 5
		echo ialess5
		ia = 0
	else
		isaddr SUBSTR <dest>, 1, 4
		ia INSTR <ADDR Addr addr>, isaddr
		echo ianotnull
	endif
	if ia
		tmp$  SUBSTR <dest>, 6
		tmp$  CATSTR <lea edx, >, tmp$
		tmp$  ;; insert lea edx, whatever
	else
		mov edx, dest	;; edx=0: use mcDefBuffer, edx=1: continue with mcLastPos$
	endif
	call MulCatCopy
	pop edi
	EXITM <eax>
ENDM

MinLampSize = 200
LAMP$ MACRO cycles:REQ, csize:REQ	; Usage: print LAMP$(cycles, size), " LAMPs", 13, 10
	ffree ST(7)			;; free the stack for pushing
	mov eax, csize
	.if eax==0
		add eax, MinLampSize
	.endif
	push eax
	fild dword ptr [esp]		;; move into ST (0)
	pop eax
	fsqrt
	push cycles
	fild dword ptr [esp]		;; push cycles on FPU
	fmul ST, ST(1)		;; multiply with sqrt(size)
	fistp dword ptr [esp]
	pop eax
	invoke dwtoa, eax, addr LampsBuffer
EXITM <offset LampsBuffer>
ENDM

.data?
LampsBuffer	dd 80 dup (?)
mcStrCounter	dd ?	; number of src arguments
mcBinCounter	dd ?	; number of BIN$s
mcHexCounter	dd ?	; number of HEX$s
mcLastPos$	dd ?	; pointer to last position for append, use with CAT$(1, ...)
mcStrBuffer	dd mcStringSlots dup (?)	; holds pointers to CAT$ args
mcBinBuffer	dd mcBinSlots*36/4 dup (?)	; holds contents of BIN$s
mcHexBuffer	dd mcHexSlots*10/4 dup (?)	; holds contents of HEX$s
mcDefBuffer	dd mcDefBufLen/4 dup (?)	; default buffer if first arg=0

; based on code by MichaelW, http://www.masm32.com/board/index.php?topic=1589.30

.code
CrLf$	dd CrLf_txt
CrLf_txt	db 13, 10, 0, 0
; 

start:
	UseOldCat = 1
	call ShowCodeSize

    LOOP_COUNT EQU 10000000
 
    print CAT$(0, CrLf$, "Ciao bello, ", "this is test A", " with the new CAT$ macro", CrLf$, "Fantastic ", str$(110), " bytes short!", CrLf$, CrLf$)
    mov byte ptr [mcDefBuffer], 0	; clear the target buffer for cat$
	if UseOldCat
	    print cat$(addr mcDefBuffer, "Ciao bello, ", "this is test B", " with the old cat$ macro", CrLf$, "Fantastic ", str$(99), " bytes short!", CrLf$, CrLf$)
	endif
	invoke Sleep, 250            ; reduced cycle count by ~26 ??
	push ebx

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
	mov eax, CAT$(0, CrLf$, "Ciao bello, ", "this is test A", " with the new CAT$ macro", CrLf$, "Fantastic ", str$(110), " bytes short!", CrLf$, CrLf$)
    counter_end
	mov ebx, eax	; store cycle count
	print ustr$(eax)
	print chr$(" clocks CAT$ ",9)
	mov eax, offset pend2
	sub eax, offset pst2
	push eax
	print str$(eax)
	print chr$(" bytes ", 9)
	pop eax
	print LAMP$(ebx, eax)
	print chr$(" LAMPs", 13, 10)

	if UseOldCat

	counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
		mov byte ptr [mcDefBuffer], 0	; clear the target buffer for cat$
		mov eax, cat$(addr mcDefBuffer, CrLf$, "Ciao bello, ", "this is test B", " with the old cat$ macro", CrLf$, "Fantastic ", str$(110), " bytes short!", CrLf$, CrLf$)
	counter_end

	mov ebx, eax	; store cycle count
	print ustr$(eax)
	print chr$(" clocks cat$ ",9)
	; mov eax, offset pend2
	; sub eax, offset pst2
	mov eax, 99	; calculated with ShowCodeSize and UseOldCat = 0
	push eax
	print str$(eax)
	print chr$(" bytes ", 9)
	pop eax
	print LAMP$(ebx, eax)
	print chr$(" LAMPs", 13, 10)
	print chr$(13, 10), "LAMPs = Lean And Mean Points = cycles * sqrt(size)", 13,10

	endif

	pop ebx

    ; invoke Sleep,250            ; reduced cycle count by ~26 ??
    ; mov   eax,input(13,10,"Press enter to exit...")
    getkey
    exit

; 
; The technique used to find the terminating null was adapted
; from the MASM32 STRLEN procedure, which was adapted from an
; algorithm written by Agner Fog.
; 
;pst1:
;SzCopy_dw proc uses ebx lpsrc:DWORD,lpdest:DWORD ; (*** not used in this test ***)
;    mov   eax,lpsrc
;    mov   edx,lpdest
;    sub   eax,4
;    sub   edx,4
;  @@:   
;    mov   ebx,[eax+4]             ; get next 4 bytes
;    add   eax,4
;    lea   ecx,[ebx-01010101h]     ; subtract 1 from each byte
;    add   edx,4
;    test  ecx,80808080h
;    jnz   @F                      ; jump if zero byte
;    mov   [edx],ebx
;    jmp   @B
;  @@:
;    mov   cl,[eax]
;    add   eax,1
;    mov   [edx],cl
;    add   edx,1
;    test  cl,cl
;    jnz   @B
;    sub   eax,lpsrc
;    sub   eax,1                    ; return length w/o null
;    ret
;SzCopy_dw endp
;pend1:

;	invoke MulCatCopy, 123, 456	; 12 bytes
;	call MulCatCopy				; 5 bytes

safe = 1

COMMENT ~
mcStrCounter	dd ?	; number of src arguments
mcBinCounter	dd ?	; number of BIN$s
mcHexCounter	dd ?	; number of HEX$s
mcLastPos$	dd ?	; last position for append, use with CAT$(1, ...)
mcStrBuffer	dd mcStringSlots dup (?)	; holds pointers to CAT$ args
mcBinBuffer	dd mcBinSlots*36/4 dup (?)	; holds contents of BIN$s
mcHexBuffer	dd mcHexSlots*10/4 dup (?)	; holds contents of HEX$s
mcDefBuffer	dd mcDefBufLen/4 dup (?)	; default buffer if first arg=0 ~

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
pst2:
MulCatCopy proc
  mcMagic = 01010101h
  ; push edi	; already saved in macro
  push ebx
  push esi
  xor eax, eax
  stosd			; mark end of args
  .if edx==0
	mov edx, offset mcDefBuffer	; edx=0, safe copy: take default 
	mov edi, mcDefBufLen		; buffer len, e.g. 1024, then add
	add edi, edx				; current pos and check below
  .else
	.if edx==1
		mov edx, mcLastPos$
	.endif
	mov edi, edx
	add edi, 0FFFFFFFh			; only edx==0 is safe ^ ^
  .endif
  mov esi, offset mcStrBuffer
  push edx	; will return a pointer
mcNext:
  lodsd	; mov eax, lpsrc, mov edx, lpdest
  or eax, eax
  jz mcDone

@@:   
  mov ebx, [eax]			; get next 4 bytes
  lea ecx,[ebx-mcMagic]	; subtract 1 from each byte
  test ecx, 80808080h
  jnz @F					; jump if zero byte
  cmp edi, edx				; safe copy...
  jle mcDone
  mov [edx], ebx			; store a dword
  add eax, 4
  add edx, 4				; inc destination
  jmp @B

@@:
  mov cl, [eax]				; copy non-aligned bytes
  mov [edx], cl
  add eax,1
  add edx,1
  test cl, cl
  jnz @B
  dec edx
  jmp mcNext

mcDone:
  mov mcLastPos$, edx	; save pointer to end of string
  pop eax					; pushed as edx, return pointer to end of string
  pop esi
  pop ebx
  ret
MulCatCopy endp
pend2:
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

BeforeChkEnd:
ShowCodeSize proc uses esi

	print chr$(13, 10, "Your code section has", 9)
	mov eax, offset BeforeChkEnd - offset start
	print str$(eax)
	print chr$(" bytes ", 40, "excluding the ShowCodeSize routine", 41, 13, 10)

	print chr$("The libraries added", 9)
	mov esi, offset AfterChkEnd

	xor ecx, ecx		; counter

@@:	inc esi
	mov eax, [esi]
	inc ecx
	cmp ecx, 4000	; 7030 works, 7040 throws an exception
	ja @F
	cmp ax, 25FFh	; a long JMP
	jne @B
	mov eax, [esi+6]
	cmp ax, 25FFh	; another long JMP exactly 6 bytes later
	jne @B

@@:	print ustr$(ecx)
	print chr$(" bytes", 13, 10, 10)

;	mov esi, offset ENDCODE
;	print chr$("The linker added", 9)
;	print str$(esi)
;	print " - "
;	mov eax, offset BeforeChkEnd
;	print str$(eax)
;	print " = "
;	sub esi, offset BeforeChkEnd
;	print str$(esi)
;	print chr$(" bytes", 13, 10, 10)

	ret
ShowCodeSize endp
AfterChkEnd:

;.code _text$
;ENDCODE equ $
end start
